



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Javascript闭包——懂不懂由你，反正我是懂了</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Javascript闭包——懂不懂由你，反正我是懂了</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 22:43:30 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>摘要：&ldquo;如果你不能向一个六岁的孩子解释清楚，那么其实你自己根本就没弄懂。&rdquo;好吧，我试着向一个27岁的朋友就是JS闭包(JavaScript closure)却彻底失败了。</div>
<div>
<div>
<p>　　越来越觉得国内没有教书育人的氛围，为了弄懂JS的闭包，我使出了我英语四级吃奶的劲去google上搜寻着有关闭包的解释，当我看到stackoverflow上<a href="http://stackoverflow.com/questions/111102/how-do-javascript-closures-work" rel="external nofollow noreferrer">这一篇解答</a>，我脑中就出现了一句话：就是这货没跑了！</p>
<p>　　不才译文见下，见笑了。</p>
<p>　　Peter Mortensen问：</p>
<blockquote><p>就像老Albert所说的，&ldquo;如果你不能向一个六岁的孩子解释清楚，那么其实你自己根本就没弄懂。&rdquo;好吧，我试着向一个27岁的朋友就是JS闭包（JavaScript closure）却彻底失败了。</p>
<p>你们会怎么把它解释给一个充满好奇心的六岁孩子听呢？</p>
<p>注：我看过StackOverflow上给出的示例，但根本没用。</p></blockquote>
<p>　　Ali的回答：</p>
<p>　　当function里嵌套function时，内部的function可以访问外部function里的变量。</p>
<pre class="prettyprint linenums">
function&nbsp;foo(x) {<br />
&nbsp;&nbsp;&nbsp;&nbsp;var&nbsp;tmp&nbsp;=&nbsp;3;<br />
&nbsp;&nbsp;&nbsp;&nbsp;function&nbsp;bar(y) {<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; alert(x&nbsp;+&nbsp;y&nbsp;+&nbsp;(++tmp));<br />
&nbsp;&nbsp;&nbsp; }<br />
&nbsp;&nbsp;&nbsp; bar(10);<br />
}<br />
foo(2)
</pre>
<p>　　不管执行多少次，都会alert 16，因为bar能访问foo的参数x，也能访问foo的变量tmp。</p>
<p>　　但，这还不是闭包。当你return的是内部function时，就是一个闭包。内部function会close-over外部function的变量直到内部function结束。</p>
<pre class="prettyprint linenums">
function&nbsp;foo(x) {<br />
&nbsp;&nbsp;&nbsp;&nbsp;var&nbsp;tmp&nbsp;=&nbsp;3;<br />
&nbsp;&nbsp;&nbsp;&nbsp;return&nbsp;function&nbsp;(y) {<br />
&nbsp;&nbsp;&nbsp; &nbsp; &nbsp; alert(x&nbsp;+&nbsp;y&nbsp;+&nbsp;(++tmp));<br />
&nbsp;&nbsp;&nbsp; }<br />
}<br />
var&nbsp;bar&nbsp;=&nbsp;foo(2);&nbsp;//&nbsp;bar 现在是一个闭包<br />
bar(10);
</pre>
<p>　　上面的脚本最终也会alert 16，因为虽然bar不直接处于foo的内部作用域，但bar还是能访问x和tmp。</p>
<p>　　但是，由于tmp仍存在于bar闭包的内部，所以它还是会自加1，而且你每次调用bar时它都会自加1.</p>
<p>　　（考虑到六岁这个限制：我们其实可以建立不止一个闭包方法，比如return它们的数组，也可以把它们设置为全局变量。它们全都指向相同的x和相同的tmp，而不是各自有一份副本。）</p>
<p>　　注：现在来整点儿七岁的内容。</p>
<p>　　上面的x是一个字面值（值传递），和JS里其他的字面值一样，当调用foo时，实参x的值被复制了一份，复制的那一份作为了foo的参数x。</p>
<p>　　那么问题来了，JS里处理object时是用到引用传递的，那么，你调用foo时传递一个object，foo函数return的闭包也会引用最初那个object！</p>
<pre class="prettyprint linenums">
function&nbsp;foo(x) {<br />
var&nbsp;tmp&nbsp;=&nbsp;3;<br />
return&nbsp;function&nbsp;(y) {<br />
&nbsp;&nbsp;&nbsp; alert(x&nbsp;+&nbsp;y&nbsp;+&nbsp;tmp);<br />
&nbsp;&nbsp;&nbsp; x.memb&nbsp;=&nbsp;x.memb&nbsp;?&nbsp;x.memb&nbsp;+&nbsp;1&nbsp;:&nbsp;1;<br />
&nbsp;&nbsp;&nbsp; alert(x.memb);<br />
&nbsp;&nbsp;&nbsp; }<br />
}<br />
var&nbsp;age&nbsp;=&nbsp;new&nbsp;Number(2);<br />
var&nbsp;bar&nbsp;=&nbsp;foo(age);&nbsp;//&nbsp;bar 现在是一个引用了age的闭包<br />
bar(10);
</pre>
<p>　　不出我们意料，每次运行bar(10)，x.memb都会自加1。但需要注意的是x每次都指向同一个object变量&mdash;&mdash;age，运行两次bar(10)后，age.memb会变成2.</p>
<p>　　这和HTML对象的内存泄漏有关，呃，不过貌似超出了答题的范围。</p>
<p>　　JohnMerlino 对Ali说：</p>
<p>　　这里有一个不用return关键字的闭包例子：</p>
<pre class="prettyprint linenums">
function&nbsp;closureExample(objID, text, timedelay) {&nbsp;<br />
&nbsp;&nbsp;&nbsp; setTimeout(function() {&nbsp;<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; document.getElementById(objID).innerHTML&nbsp;=&nbsp;text;&nbsp;<br />
&nbsp;&nbsp;&nbsp; }, timedelay);&nbsp;<br />
}&nbsp;<br />
closureExample(&lsquo;myDiv&rsquo;, &lsquo;Closure is created&rsquo;,&nbsp;500);
</pre>
<p>　　深夜1:37 John Pick这样回答：</p>
<p>　　JS里的function能访问它们的：</p>
<p>　　1. 参数</p>
<p>　　2. 局部变量或函数</p>
<p>　　3. 外部变量（环境变量？），包括</p>
<blockquote><p>3.1 全局变量，包括DOM。</p>
<p>3.2 外部函数的变量或函数。</p></blockquote>
<p>　　如果一个函数访问了它的外部变量，那么它就是一个闭包。</p>
<p>　　注意，外部函数不是必需的。通过访问外部变量，一个闭包可以维持（keep alive）这些变量。在内部函数和外部函数的例子中，外部函数可以创建局部变量，并且最终退出；但是，如果任何一个或多个内部函数在它退出后却没有退出，那么内部函数就维持了外部函数的局部数据。</p>
<p>　　一个典型的例子就是全局变量的使用。</p>
<p>　　mykhal这样回答：</p>
<p>　　Wikipedia对闭包的定义是这样的：</p>
<blockquote><p>In computer science, a closure is a function together with a referencing environment for the nonlocal names (free variables) of that function.</p></blockquote>
<p>　　从技术上来讲，在JS中，每个function都是闭包，因为它总是能访问在它外部定义的数据。</p>
<p>　　Since&nbsp;<strong>scope-defining construction in Javascript is a function</strong>, not a code block like in many other languages,&nbsp;<strong>what we usually mean by&nbsp;<em>closure</em>&nbsp;in Javascript</strong>&nbsp;is a&nbsp;<strong>fuction working with nonlocal variables defined in already executed surrounding function</strong>.</p>
<p>　　闭包经常用于创建含有隐藏数据的函数（但并不总是这样）。</p>
<pre class="prettyprint linenums">
var&nbsp;db&nbsp;=&nbsp;(function() {<br />
//&nbsp;创建一个隐藏的object, 这个object持有一些数据<br />
//&nbsp;从外部是不能访问这个object的<br />
var&nbsp;data&nbsp;=&nbsp;{};<br />
//&nbsp;创建一个函数, 这个函数提供一些访问data的数据的方法<br />
return&nbsp;function(key, val) {<br />
&nbsp;&nbsp;&nbsp; if&nbsp;(val&nbsp;===&nbsp;undefined) {&nbsp;return&nbsp;data[key] }&nbsp;//&nbsp;get<br />
&nbsp;&nbsp;&nbsp;&nbsp;else&nbsp;{&nbsp;return&nbsp;data[key]&nbsp;=&nbsp;val }&nbsp;//&nbsp;set<br />
&nbsp;&nbsp;&nbsp; }<br />
//&nbsp;我们可以调用这个匿名方法<br />
//&nbsp;返回这个内部函数，它是一个闭包<br />
})();

db('x');&nbsp;//&nbsp;返回 undefined<br />
db('x',&nbsp;1);&nbsp;//&nbsp;设置data['x']为1<br />
db('x');&nbsp;//&nbsp;返回 1<br />
//&nbsp;我们不可能访问data这个object本身<br />
//&nbsp;但是我们可以设置它的成员
</pre>
<p>　　看了这么多外国大牛的解答，不知道你懂还是不懂，反正我是懂了。</p>
<p>　　P.S. 发布文章之后看到@xiaotie的<a href="http://www.cnblogs.com/xiaotie/archive/2011/08/03/2126145.html" rel="external nofollow noreferrer">一篇文章</a>，觉得有必要推荐一下，因为其剖析得更为深入。有人说应该在文章结尾对闭包进行总结，可惜小弟才疏学浅，不能给出一个精辟的总结。</p>
<p>　　@xiaotie对闭包的总结如下：</p>
<blockquote><p>（1）闭包是一种设计原则，它通过分析上下文，来简化用户的调用，让用户在不知晓的情况下，达到他的目的；</p>
<p>（2）网上主流的对闭包剖析的文章实际上是和闭包原则反向而驰的，如果需要知道闭包细节才能用好的话，这个闭包是设计失败的；</p>
<p>（3）尽量少学习。</p></blockquote>
<p>　　大家学习学习。</p>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qylykg8.html">python基础教程1</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g73re9.html">&period;NET 扩展方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gopw0q.html">【循序渐进学Python】4&period; Python中的序列&mdash;&mdash;字典</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdndov9.html">数据爬取ing</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1ejox9.html">音频&lpar;3&rpar;Android TTS技术支持朗读英文</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn4l66q.html">poj 1011 搜索减枝</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz17k08.html">C&sol;C&plus;&plus;基础知识总结&mdash;&mdash;数据的共享与保护</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eymljm9.html">prototype原型解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gedzk08.html">关于极光推送在手机系统低于iOS10的手机上闪退的问题。</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pzxj38.html">记录项目版本升级angular4 ~ angular5</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z371e9.html">总结过滤器，监听器，servlet的异同点，已经执行顺序。</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1pk4gq.html">java类型转换小技巧</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o15vm1q.html">相关子查询和嵌套子查询 &lbrack;SQL Server&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4xrrz9.html">【读书笔记】iOS-处理内存警告</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjww5z9.html">airflow-operator 可以管理airflow 的kuberntes 自定义controller  &amp;amp&semi;&amp;amp&semi; crd</a>
		</li>
						<li><a href="https://www.batexi.com/a/963m7o49.html">linux下c语言获取当前时间</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4vy0eq.html">SQL学习之SQL注入学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qve3v619.html">window&period;open 防止浏览器拦截</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnn44e2q.html">SpringCloud使用Feign出现java&period;lang&period;ClassNotFoundException&colon; org&period;springframework&period;cloud&period;client&period;loadbalancer&period;LoadBalancedRetryFactory异常</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql14ojx9.html">Vue实例对象的数据选项（火柴）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/e9jgkoe9.html">php Hash Table&lpar;三&rpar; Hash Table初始化</a>
			</li>
						<li><a href="https://www.batexi.com/a/rql2mxe8.html">oracle中的sql&percnt;rowcount&comma;sql&percnt;found、sql&percnt;notfound、sql&percnt;rowcount和sql&percnt;isopen</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jr0gwq.html">【struts2】Result和ResultType</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mvewr8.html">CSS样式表继承详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/rql2jk68.html">【8-30】oracle数据库学习</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyly328.html">oracle中的nvl&lpar;&rpar;&comma; nvl2&lpar;&rpar;函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96kmm3q.html">闲扯json取值，联想map取值。</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93ljdz9.html">Outlook不能打开附件（提示：无法创建文件xx，请右键单击要在其中创建文件的文件夹&period;&period;）</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pymr49.html">Hadoop Fsimage 和 editlog</a>
			</li>
						<li><a href="https://www.batexi.com/a/495vm7mq.html">svn还原到指定版本</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
